require 'rox/server/flags/rox_flag'
require 'rox/server/flags/rox_string'

module E2E
  class Container
    attr_accessor :simple_flag, :simple_flag_overwritten, :flag_for_impression,
                  :flag_for_impression_with_experiment_and_context, :flag_custom_properties,
                  :flag_target_groups_all, :flag_target_groups_any, :flag_target_groups_none,
                  :variant_with_context, :variant, :variant_overwritten, :flag_for_dependency,
                  :flag_dependent, :flag_color_dependent_with_context

    def initialize
      @simple_flag = Rox::Server::RoxFlag.new(true)
      @simple_flag_overwritten = Rox::Server::RoxFlag.new(true)

      @flag_for_impression = Rox::Server::RoxFlag.new(false)
      @flag_for_impression_with_experiment_and_context = Rox::Server::RoxFlag.new(false)

      @flag_custom_properties = Rox::Server::RoxFlag.new

      @flag_target_groups_all = Rox::Server::RoxFlag.new
      @flag_target_groups_any = Rox::Server::RoxFlag.new
      @flag_target_groups_none = Rox::Server::RoxFlag.new

      @variant_with_context = Rox::Server::RoxString.new('red', %w[red blue green])

      @variant = Rox::Server::RoxString.new('red', %w[red blue green])
      @variant_overwritten = Rox::Server::RoxString.new('red', %w[red blue green])

      @flag_for_dependency = Rox::Server::RoxFlag.new(false)
      @flag_dependent = Rox::Server::RoxFlag.new(false)
      @flag_color_dependent_with_context = Rox::Server::RoxString.new('White', %w[White Blue Green Yellow])
    end
  end
end
