module E2E
  class CustomProps
    def self.create_custom_props
      Rox::Server::RoxServer.set_custom_string_property('string_prop1', 'Hello')
      Rox::Server::RoxServer.set_custom_string_property('string_prop2') do |_context|
        TestVars.is_computed_string_prop_called = true
        'World'
      end

      Rox::Server::RoxServer.set_custom_boolean_property('bool_prop1', true)
      Rox::Server::RoxServer.set_custom_boolean_property('bool_prop2') do |_context|
        TestVars.is_computed_boolean_prop_called = true
        false
      end

      Rox::Server::RoxServer.set_custom_int_property('int_prop1', 6)
      Rox::Server::RoxServer.set_custom_int_property('int_prop2') do |_context|
        TestVars.is_computed_int_prop_called = true
        28
      end

      Rox::Server::RoxServer.set_custom_float_property('float_prop1', 3.14)
      Rox::Server::RoxServer.set_custom_float_property('float_prop2') do |_context|
        TestVars.is_computed_float_prop_called = true
        1.618
      end

      Rox::Server::RoxServer.set_custom_semver_property('smvr_prop1', '9.11.2001')
      Rox::Server::RoxServer.set_custom_semver_property('smvr_prop2') do |_context|
        TestVars.is_computed_semver_prop_called = true
        '20.7.1969'
      end

      Rox::Server::RoxServer.set_custom_boolean_property('bool_prop_target_group_for_variant') do |context|
        context['isDuckAndCover']
      end

      Rox::Server::RoxServer.set_custom_boolean_property('bool_prop_target_group_operand1') do |_context|
        TestVars.target_group1
      end

      Rox::Server::RoxServer.set_custom_boolean_property('bool_prop_target_group_operand2') do |_context|
        TestVars.target_group2
      end

      Rox::Server::RoxServer.set_custom_boolean_property('bool_prop_target_group_for_dependency') do |_context|
        TestVars.is_prop_for_target_group_for_dependency
      end

      Rox::Server::RoxServer.set_custom_boolean_property('bool_prop_target_group_for_variant_dependency') do |context|
        context['isDuckAndCover']
      end
    end
  end
end
