$LOAD_PATH.unshift File.expand_path('../lib', __dir__)

require 'rox/server/rox_server'
require 'rox/server/rox_options'

API_HOST = 'http://localhost:8557'.freeze
APP_KEY = '600571e330819d4842999e4f'.freeze
DEV_MODE_SECRET = 'e56cda16749d8d0a9b91d34c'.freeze

class Flags
  attr_accessor :boolean_flag, :string_flag, :int_flag, :double_flag

  def initialize
    # Define the feature flags
    @boolean_flag = Rox::Server::RoxFlag.new(true)
    @string_flag = Rox::Server::RoxString.new('option 1', ['option 1', 'option 2', 'option 3'])
    @int_flag = Rox::Server::RoxInt.new(1, [1, 2, 3])
    @double_flag = Rox::Server::RoxDouble.new(4.0, [5.0, 6.0])
  end
end

flags = Flags.new
Rox::Server::RoxServer.register(flags)

options = Rox::Server::RoxOptions.new(
  self_managed_options: Rox::Server::SelfManagedOptions.new(
    server_url: API_HOST,
    analytics_url: 'http://127.0.0.1:8787'
  ),
  dev_mode_key: DEV_MODE_SECRET
)

Rox::Server::RoxServer.setup(APP_KEY, options)

puts "boolean_flag is #{flags.boolean_flag.enabled?}"
puts "boolean_flag is #{Rox::Server::RoxServer.dynamic_api.enabled?('boolean_flag', true)} (dynamic api)"
puts "boolean_flag is #{Rox::Server::RoxServer.dynamic_api.enabled?('boolean_flag', true)} (dynamic api)"
puts "string_flag is #{flags.string_flag.value}"
puts "int_flag is #{flags.int_flag.value}"
puts "double_flag is #{flags.double_flag.value}"
