require 'rox/core/entities/flag'

module Rox
  module Core
    class InternalFlags
      @@defaults_self_managed = {
        'rox.internal.pushUpdates' => false,
        'rox.internal.considerThrottleInPush' => false,
        'rox.internal.throttleFetchInSeconds' => 0
      }

      def initialize(experiment_repository, parser, rox_options)
        @experiment_repository = experiment_repository
        @parser = parser
        @rox_options = rox_options
      end

      def enabled?(flag_name)
        if @rox_options.self_managed?
          value = @@defaults_self_managed[flag_name]
          return value unless value.nil?
        end

        internal_experiment = @experiment_repository.experiment_by_flag(flag_name)
        return false if internal_experiment.nil?

        value = @parser.evaluate_expression(internal_experiment.condition, nil).string_value
        value == Flag::FLAG_TRUE_VALUE
      end
    end
  end
end
