require 'rox/core/configuration/fetcher_error'
require 'rox/core/configuration/fetcher_status'

module Rox
  module Core
    class ConfigurationFetchedArgs
      attr_accessor :fetcher_status, :creation_date, :has_changes, :error_details

      def initialize(fetcher_status, creation_date, has_changes)
        @fetcher_status = fetcher_status
        @creation_date = creation_date
        @has_changes = has_changes
        @error_details = FetcherError::NO_ERROR
      end

      def self.error(error_details)
        args = ConfigurationFetchedArgs.new(FetcherStatus::ERROR_FETCHED_FAILED, nil, false)
        args.error_details = error_details
        args
      end
    end
  end
end
