module Rox
  module Core
    module Environment
      def self.roxy_internal_path
        'device/request_configuration'
      end

      def self.cdn_path
        case ENV['ROLLOUT_MODE']
        when 'QA'
          'https://qa-conf.rollout.io'
        when 'LOCAL'
          'https://development-conf.rollout.io'
        else
          'https://conf.rollout.io'
        end
      end

      def self.api_path(api_url = nil)
        case ENV['ROLLOUT_MODE']
        when 'QA'
          'https://qa-api.rollout.io/device/get_configuration'
        when 'LOCAL'
          'http://127.0.0.1:8557/device/get_configuration'
        else
          api_url ||= 'https://x-api.rollout.io'
          "#{api_url}/device/get_configuration"
        end
      end

      def self.state_cdn_path
        case ENV['ROLLOUT_MODE']
        when 'QA'
          'https://qa-statestore.rollout.io'
        when 'LOCAL'
          'https://development-statestore.rollout.io'
        else
          'https://statestore.rollout.io'
        end
      end

      def self.state_api_path(api_url = nil)
        case ENV['ROLLOUT_MODE']
        when 'QA'
          'https://qa-api.rollout.io/device/update_state_store'
        when 'LOCAL'
          'http://127.0.0.1:8557/device/update_state_store'
        else
          api_url ||= 'https://x-api.rollout.io'
          "#{api_url}/device/update_state_store"
        end
      end

      def self.analytics_path(analytics_url = 'https://analytic.rollout.io')
        case ENV['ROLLOUT_MODE']
        when 'QA'
          'https://qaanalytic.rollout.io'
        when 'LOCAL'
          'http://127.0.0.1:8787'
        else
          analytics_url
        end
      end

      def self.notifications_path
        case ENV['ROLLOUT_MODE']
        when 'QA'
          'https://qax-push.rollout.io/sse'
        when 'LOCAL'
          'http://127.0.0.1:8887/sse'
        else
          'https://push.rollout.io/sse'
        end
      end
    end
  end
end
