module Rox
  module Core
    class PropertyType
      attr_accessor :value, :name

      def initialize(value, name)
        @value = value
        @name = name
      end

      CACHE_MISS_RELATIVE_URL = PropertyType.new(1, 'cache_miss_relative_url')
      PACKAGE_NAME = PropertyType.new(2, 'package_name')
      VERSION_NAME = PropertyType.new(3, 'version_name')
      LIB_VERSION = PropertyType.new(4, 'lib_version')
      ROLLOUT_BUILD = PropertyType.new(5, 'rollout_build')
      API_VERSION = PropertyType.new(6, 'api_version')
      BUID = PropertyType.new(7, 'buid')
      BUID_GENERATORS_LIST = PropertyType.new(8, 'buid_generators_list')
      APP_VERSION = PropertyType.new(9, 'app_version')
      APP_RELEASE = PropertyType.new(10, 'app_release')
      DISTINCT_ID = PropertyType.new(11, 'distinct_id')
      APP_KEY = PropertyType.new(12, 'app_key')
      FEATURE_FLAGS = PropertyType.new(13, 'feature_flags')
      CUSTOM_PROPERTIES = PropertyType.new(14, 'custom_properties')
      PLATFORM = PropertyType.new(15, 'platform')
      DEV_MODE_SECRET = PropertyType.new(16, 'dev_mode_secret')
      STATE_MD5 = PropertyType.new(17, 'state_md5')
    end
  end
end
