require 'rox/core/network/configuration_source'
require 'rox/core/network/configuration_fetch_result'
require 'rox/core/network/configuration_fetcher_base'

module Rox
  module Core
    class ConfigurationFetcherRoxy < ConfigurationFetcherBase
      def fetch
        source = ConfigurationSource::ROXY
        begin
          fetch_roxy = fetch_from_roxy
          if fetch_roxy.success?
            return ConfigurationFetchResult.new(fetch_roxy.text, source)
          else
            write_fetch_error_to_log_and_invoke_fetch_handler(source, fetch_roxy)
          end
        rescue StandardError => e
          write_fetch_exception_to_log_and_invoke_fetch_handler(source, e)
        end

        nil
      end

      def fetch_from_roxy
        @request.send_get(@request_configuration_builder.build_for_roxy)
      end
    end
  end
end
