require 'rox/core/entities/flag'
require 'rox/core/utils/type_utils'

module Rox
  module Core
    class EvaluationResult
      attr_reader :value

      def initialize(value)
        @value = value
      end

      def bool_value
        return false if value.nil?
        return value if Utils.boolean?(value)

        nil
      end

      def string_value
        return value if value.is_a? String
        return nil if value.nil?
        return Flag::FLAG_TRUE_VALUE if value
        return Flag::FLAG_FALSE_VALUE unless value

        nil
      end
    end
  end
end
