class Debouncer
  def initialize(delay_in_seconds, block)
    @delay_in_seconds = delay_in_seconds
    @block = block
    @delay_until = Time.now
  end

  def call
    now = Time.now
    if now > @delay_until
      @delay_until = now + @delay_in_seconds
      Thread.new do
        sleep(@delay_in_seconds)
        @block.call
      end
    end
  end
end
