require 'rox/server/flags/rox_flag'
require 'rox/server/flags/rox_string'
require 'rox/server/flags/rox_int'
require 'rox/server/flags/rox_double'

module Rox
  module Server
    class ServerEntitiesProvider
      def create_flag(default_value)
        Rox::Server::RoxFlag.new(default_value)
      end

      def create_string(default_value, options)
        Rox::Server::RoxString.new(default_value, options)
      end

      def create_int(default_value, options)
        Rox::Server::RoxInt.new(default_value, options)
      end

      def create_double(default_value, options)
        Rox::Server::RoxDouble.new(default_value, options)
      end
    end
  end
end
