require 'logger'

module Rox
  module Server
    class ServerLogger
      def initialize
        @logger = Logger.new($stdout)
      end

      def debug(message, ex = nil)
        if ex.nil?
          @logger.debug(message)
        else
          @logger.debug("#{message}. Exception: #{ex}")
        end
      end

      def error(message, ex = nil)
        if ex.nil?
          @logger.error(message)
        else
          @logger.error("#{message}. Exception: #{ex}")
        end
      end

      def warn(message, ex = nil)
        if ex.nil?
          @logger.warn(message)
        else
          @logger.warn("#{message}. Exception: #{ex}")
        end
      end
    end
  end
end
